[TOC]

Minecraft版本为：`1.20.6`
对应java版本>=21
## 安装java

下载jdk
```shell
# 下载jdk21
wget https://download.oracle.com/java/21/latest/jdk-21_linux-x64_bin.tar.gz
# 华为云镜像
wget https://mirrors.huaweicloud.com/openjdk/21/openjdk-21_linux-x64_bin.tar.gz
```
解压
```shell
tar -zxf openjdk-21_linux-x64_bin.tar.gz -C /usr/local/
```
重命名为java21
```shell
cd /usr/local
mv jdk-21/ java21
```
安装java
```shell
JAVA_INSTALL_PATH='/usr/local/java21'
echo "export JAVA_HOME=\"${JAVA_INSTALL_PATH}\"" >> /etc/profile
echo "export PATH=\$JAVA_HOME/bin:\$PATH" >> /etc/profile
echo "export CLASSPATH=.:\$JAVA_HOME/lib/dt.jar:\$JAVA_HOME/lib/tools.jar" >> /etc/profile
source /etc/profile
java

```

## 安装Minecraft服务端
此处为安装官方版本，可以安装neoforge，请参照安装neoforge
到`https://mcversions.net/`官网下载对应的版本的Server.jar，放到合适的目录下

## 启动服务器

第一次启动使用以下命令初始化并生成配置文件。
```shell
java -jar ./server.jar --initSettings
echo 'eula=true' > eula.txt # 用于同意用户协议
# 可以在java后面添加参数限制内存分配，看个人需求
java -Xmx1024M -Xms1024M -jar ./server.jar --initSettings
```

之后可以使用以下命令运行world/taohua目录下的世界，端口为10000
```shell
java -Xmx2048M -Xms2048M -jar ./server.jar --world world/taohua --port 10000 --nogui
```
更多参数`https://zh.minecraft.wiki/w/Tutorial:%E6%9E%B6%E8%AE%BE%E6%9C%8D%E5%8A%A1%E5%99%A8`


##使用启动脚本

编写两个脚本

`start.sh` 开始脚本

```shell
cd $(dirname "$0")
if screen -list | grep -q "minecraft"; then
	echo "minecraft 已经启动了"
else
	# 使用 `screen` 启动一个新会话，并在其中运行程序
	screen -dmS minecraft java -Xmx2048M -Xms2048M -jar ./server.jar --world world/taohua --port 10000 --nogui
	echo "开始启动我的世界."
fi
```

`reattach.sh` 重回控制台脚本

```shell
cd $(dirname "$0")
path="" # 程序bin目录路径
if screen -list | grep -q "minecraft"; then
	cd $path
	screen -r minecraft
else
	echo "没有找到我的世界"
fi
```
赋权

```shell
chmod 755 reattach.sh start.sh
```

## 安装neoforage

到`https://neoforged.net/`下载jar安装包，并使用`java -jar neoforge.jar` 运行安装

到安装目录运行`run.sh`

如`./run.sh --world world/taohua --port 10000`



## 报错解决
ubuntu 上报错
```txt
java.lang.UnsatisfiedLinkError: /usr/local/java21/lib/libawt_xawt.so: libXrender.so.1: cannot open shared object file: No such file or directory
```
安装以下包即可
```shell
apt-get install libxrender-dev
apt-get install libxtst-dev
```